ber1=function(p,a,N)
  #Monte Carlo estimation of P(S>=a), S=X1+...+Xn
{
  n=length(p)
  res=rep(0,N)
  for (j in 1:N)
  {
    x=rep(0,n)
    for (i in 1:n) x[i]=rbinom(1,1,p[i])
    S=sum(x)
    res[j]=(S>=a)
  }
  m=mean(res)
  stdev=sd(res)
  return(c(m,stdev))
}
#
p=seq(0.1, 0.3, 0.04)
sum(p)
#
m1=ber1(p, 4, 1000)
m1
#
#Importance Sampling
#
M=function(p,t,a)
{
  n=length(p)
  v=(1-p)/(p*exp(t)+1-p)
  return(sum(v)-n+a)
}
# 
a=4
t=seq(1.7,2.3, 0.01)
v=rep(0, length(t))
for (k in (1:length(t)))
{
  v[k]=M(p,t[k],a)
}
plot(v~t)
M(p,2.18,a)
t0=2.18
pt=p*exp(t0)/(p*exp(t0)+1-p)
pt
p
sum(pt)
#
ber2=function(p,t0,a,N)
{
  n=length(p)
  pt=p*exp(t0)/(p*exp(t0)+1-p)
  Mt=prod(p*exp(t0)+1-p)
  print(Mt)
  res=matrix(rep(0,2*N),N,2)
  for (j in 1:N)
  {
    x=rep(0,n)
    for (i in 1:n) x[i]=rbinom(1,1,pt[i])
    S=sum(x)
    res[j,]=c(S,(S>=a)*Mt*exp(-t0*S))
  }
  m=mean(res[,2])
  stdev=sd(res[,2])
  return(c(m,stdev))
}
m2=ber2(p,2.18, 4, 1000)
m2


